#version 430 core
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;


uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform float t;
uniform bool isWater;

void main() {
	
	vec3 distance = vec3(0,0,0);
	vec3 direction = vec3(0.0f,0.75f, 0.25f);
	if (isWater) {		
		distance = (0.1f*sin(direction*uv[0]*50.25 + t))*normal;
	}
	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	vec4 position_world_ = modelMatrix * vec4(position.xyz + distance, 1);
	vert.position_world = position_world_.xyz;

	if(isWater) {
		vec3 n = vec3(-(0.25f*cos(uv[0]+t)),1,-(0.25f*cos(uv[0]+t)));
		vert.normal_world = normalMatrix*n;
	}	

	gl_Position = viewProjMatrix * position_world_;
}